/* DesktopIntegration.c generated by valac 0.54.2, the Vala compiler
 * generated from DesktopIntegration.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gint64 _desktop_integration_app_info_comparator_comparator (void* a,
                                                            void* b,
                                                            gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

GAppInfo*
desktop_integration_get_default_app_for_mime_types (gchar** mime_types,
                                                    gint mime_types_length1,
                                                    GeeArrayList* preferred_apps)
{
	SortedList* external_apps = NULL;
	SortedList* _tmp0_;
	GAppInfo* result = NULL;
	g_return_val_if_fail (preferred_apps != NULL, NULL);
	_tmp0_ = desktop_integration_get_apps_for_mime_types (mime_types, (gint) mime_types_length1);
	external_apps = _tmp0_;
	{
		GeeArrayList* _preferred_app_list = NULL;
		gint _preferred_app_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _preferred_app_index = 0;
		_preferred_app_list = preferred_apps;
		_tmp1_ = _preferred_app_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_preferred_app_size = _tmp3_;
		_preferred_app_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gchar* preferred_app = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_preferred_app_index = _preferred_app_index + 1;
			_tmp4_ = _preferred_app_index;
			_tmp5_ = _preferred_app_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _preferred_app_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _preferred_app_index);
			preferred_app = (gchar*) _tmp7_;
			{
				GeeIterator* _external_app_it = NULL;
				SortedList* _tmp8_;
				GeeIterator* _tmp9_;
				_tmp8_ = external_apps;
				_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
				_external_app_it = _tmp9_;
				while (TRUE) {
					GeeIterator* _tmp10_;
					GAppInfo* external_app = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					GAppInfo* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_tmp10_ = _external_app_it;
					if (!gee_iterator_next (_tmp10_)) {
						break;
					}
					_tmp11_ = _external_app_it;
					_tmp12_ = gee_iterator_get (_tmp11_);
					external_app = (GAppInfo*) _tmp12_;
					_tmp13_ = external_app;
					_tmp14_ = g_app_info_get_name (_tmp13_);
					_tmp15_ = preferred_app;
					if (string_contains (_tmp14_, _tmp15_)) {
						result = external_app;
						_g_object_unref0 (_external_app_it);
						_g_free0 (preferred_app);
						_g_object_unref0 (external_apps);
						return result;
					}
					_g_object_unref0 (external_app);
				}
				_g_object_unref0 (_external_app_it);
			}
			_g_free0 (preferred_app);
		}
	}
	result = NULL;
	_g_object_unref0 (external_apps);
	return result;
}

gint64
desktop_integration_app_info_comparator (void* a,
                                         void* b)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint64 _tmp6_;
	gint64 result = 0LL;
	_tmp0_ = g_app_info_get_name (G_TYPE_CHECK_INSTANCE_CAST (a, g_app_info_get_type (), GAppInfo));
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_app_info_get_name (G_TYPE_CHECK_INSTANCE_CAST (b, g_app_info_get_type (), GAppInfo));
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
	_tmp5_ = _tmp4_;
	_tmp6_ = (gint64) g_utf8_collate (_tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	result = _tmp6_;
	return result;
}

static gint64
_desktop_integration_app_info_comparator_comparator (void* a,
                                                     void* b,
                                                     gpointer self)
{
	gint64 result;
	result = desktop_integration_app_info_comparator (a, b);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

SortedList*
desktop_integration_get_apps_for_mime_types (gchar** mime_types,
                                             gint mime_types_length1)
{
	SortedList* external_apps = NULL;
	SortedList* _tmp0_;
	SortedList* result = NULL;
	_tmp0_ = sorted_list_new (g_app_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _desktop_integration_app_info_comparator_comparator, NULL);
	external_apps = _tmp0_;
	if (mime_types_length1 == 0) {
		result = external_apps;
		return result;
	}
	{
		gchar** mime_type_collection = NULL;
		gint mime_type_collection_length1 = 0;
		gint _mime_type_collection_size_ = 0;
		gint mime_type_it = 0;
		mime_type_collection = mime_types;
		mime_type_collection_length1 = mime_types_length1;
		for (mime_type_it = 0; mime_type_it < mime_type_collection_length1; mime_type_it = mime_type_it + 1) {
			gchar* _tmp1_;
			gchar* mime_type = NULL;
			_tmp1_ = g_strdup (mime_type_collection[mime_type_it]);
			mime_type = _tmp1_;
			{
				gchar* content_type = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				const gchar* _tmp5_;
				GList* _tmp6_;
				_tmp2_ = mime_type;
				_tmp3_ = g_content_type_from_mime_type (_tmp2_);
				content_type = _tmp3_;
				_tmp4_ = content_type;
				if (_tmp4_ == NULL) {
					_g_free0 (content_type);
					_g_free0 (mime_type);
					break;
				}
				_tmp5_ = content_type;
				_tmp6_ = g_app_info_get_all_for_type (_tmp5_);
				{
					GList* external_app_collection = NULL;
					GList* external_app_it = NULL;
					external_app_collection = _tmp6_;
					for (external_app_it = external_app_collection; external_app_it != NULL; external_app_it = external_app_it->next) {
						GAppInfo* _tmp7_;
						GAppInfo* external_app = NULL;
						_tmp7_ = _g_object_ref0 ((GAppInfo*) external_app_it->data);
						external_app = _tmp7_;
						{
							gboolean already_contains = FALSE;
							gboolean _tmp17_ = FALSE;
							already_contains = FALSE;
							{
								GeeIterator* _app_it = NULL;
								SortedList* _tmp8_;
								GeeIterator* _tmp9_;
								_tmp8_ = external_apps;
								_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
								_app_it = _tmp9_;
								while (TRUE) {
									GeeIterator* _tmp10_;
									GAppInfo* app = NULL;
									GeeIterator* _tmp11_;
									gpointer _tmp12_;
									GAppInfo* _tmp13_;
									const gchar* _tmp14_;
									GAppInfo* _tmp15_;
									const gchar* _tmp16_;
									_tmp10_ = _app_it;
									if (!gee_iterator_next (_tmp10_)) {
										break;
									}
									_tmp11_ = _app_it;
									_tmp12_ = gee_iterator_get (_tmp11_);
									app = (GAppInfo*) _tmp12_;
									_tmp13_ = app;
									_tmp14_ = g_app_info_get_name (_tmp13_);
									_tmp15_ = external_app;
									_tmp16_ = g_app_info_get_name (_tmp15_);
									if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
										already_contains = TRUE;
										_g_object_unref0 (app);
										break;
									}
									_g_object_unref0 (app);
								}
								_g_object_unref0 (_app_it);
							}
							if (!already_contains) {
								GAppInfo* _tmp18_;
								const gchar* _tmp19_;
								_tmp18_ = external_app;
								_tmp19_ = g_app_info_get_name (_tmp18_);
								_tmp17_ = !string_contains (_tmp19_, _ (RESOURCES_APP_DIRECT_ROLE));
							} else {
								_tmp17_ = FALSE;
							}
							if (_tmp17_) {
								SortedList* _tmp20_;
								GAppInfo* _tmp21_;
								_tmp20_ = external_apps;
								_tmp21_ = external_app;
								gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
							}
							_g_object_unref0 (external_app);
						}
					}
					(external_app_collection == NULL) ? NULL : (external_app_collection = (_g_list_free__g_object_unref0_ (external_app_collection), NULL));
				}
				_g_free0 (content_type);
				_g_free0 (mime_type);
			}
		}
	}
	result = external_apps;
	return result;
}

gchar*
desktop_integration_get_app_open_command (GAppInfo* app_info)
{
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (app_info != NULL, NULL);
	_tmp0_ = g_app_info_get_commandline (app_info);
	_tmp1_ = g_strdup (_tmp0_);
	str = _tmp1_;
	_tmp3_ = str;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		_tmp4_ = str;
		_tmp2_ = _tmp4_;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = g_app_info_get_executable (app_info);
		_tmp2_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp2_);
	result = _tmp6_;
	_g_free0 (str);
	return result;
}

