/* ExportDialog.c generated by valac 0.54.2, the Vala compiler
 * generated from ExportDialog.vala, do not modify */

/*
* Copyright 2009-2013 Yorba Foundation
*           2017-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.photos.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

enum  {
	EXPORT_DIALOG_0_PROPERTY,
	EXPORT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* export_dialog_properties[EXPORT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ExportDialogPrivate {
	GtkComboBoxText* quality_combo;
	GtkComboBoxText* constraint_combo;
	GtkComboBoxText* format_combo;
	GtkCheckButton* export_metadata;
	GeeArrayList* format_options;
	GtkSpinButton* pixels_spinbutton;
	GtkWidget* export_button;
};

static gint ExportDialog_private_offset;
static gpointer export_dialog_parent_class = NULL;
static ScaleConstraint export_dialog_current_constraint;
static ScaleConstraint export_dialog_current_constraint = SCALE_CONSTRAINT_ORIGINAL;
static ExportFormatParameters export_dialog_current_parameters;
static ExportFormatParameters export_dialog_current_parameters = {0};
static gint export_dialog_current_scale;
static gint export_dialog_current_scale = 1200;

static void export_dialog_format_add_option (ExportDialog* self,
                                      const gchar* format_name);
static void export_dialog_format_set_active_text (ExportDialog* self,
                                           const gchar* text);
static PhotoFileFormat export_dialog_get_specified_format (ExportDialog* self);
static gchar* export_dialog_get_label_for_parameters (ExportDialog* self,
                                               ExportFormatParameters* params);
static void export_dialog_on_format_changed (ExportDialog* self);
static void export_dialog_on_constraint_changed (ExportDialog* self);
static void export_dialog_on_pixels_changed (ExportDialog* self);
static GObject * export_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void _export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self);
static void _export_dialog___lambda41_ (ExportDialog* self);
static void __export_dialog___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                                     gpointer self);
static void export_dialog_finalize (GObject * obj);
static GType export_dialog_get_type_once (void);

const ScaleConstraint EXPORT_DIALOG_CONSTRAINT_ARRAY[4] = {SCALE_CONSTRAINT_ORIGINAL, SCALE_CONSTRAINT_DIMENSIONS, SCALE_CONSTRAINT_WIDTH, SCALE_CONSTRAINT_HEIGHT};
const JpegQuality EXPORT_DIALOG_QUALITY_ARRAY[4] = {JPEG_QUALITY_LOW, JPEG_QUALITY_MEDIUM, JPEG_QUALITY_HIGH, JPEG_QUALITY_MAXIMUM};

static inline gpointer
export_dialog_get_instance_private (ExportDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ExportDialog_private_offset);
}

ExportDialog*
export_dialog_construct (GType object_type,
                         const gchar* title)
{
	ExportDialog * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	self = (ExportDialog*) g_object_new (object_type, "resizable", FALSE, "title", title, NULL);
	return self;
}

ExportDialog*
export_dialog_new (const gchar* title)
{
	return export_dialog_construct (TYPE_EXPORT_DIALOG, title);
}

static void
export_dialog_format_add_option (ExportDialog* self,
                                 const gchar* format_name)
{
	GeeArrayList* _tmp0_;
	GtkComboBoxText* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (format_name != NULL);
	_tmp0_ = self->priv->format_options;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, format_name);
	_tmp1_ = self->priv->format_combo;
	gtk_combo_box_text_append_text (_tmp1_, format_name);
}

static void
export_dialog_format_set_active_text (ExportDialog* self,
                                      const gchar* text)
{
	gint selection_ticker = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	selection_ticker = 0;
	{
		GeeArrayList* _current_text_list = NULL;
		GeeArrayList* _tmp0_;
		gint _current_text_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _current_text_index = 0;
		_tmp0_ = self->priv->format_options;
		_current_text_list = _tmp0_;
		_tmp1_ = _current_text_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_current_text_size = _tmp3_;
		_current_text_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gchar* current_text = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			gint _tmp10_;
			_current_text_index = _current_text_index + 1;
			_tmp4_ = _current_text_index;
			_tmp5_ = _current_text_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _current_text_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _current_text_index);
			current_text = (gchar*) _tmp7_;
			_tmp8_ = current_text;
			if (g_strcmp0 (_tmp8_, text) == 0) {
				GtkComboBoxText* _tmp9_;
				_tmp9_ = self->priv->format_combo;
				gtk_combo_box_set_active ((GtkComboBox*) _tmp9_, selection_ticker);
				_g_free0 (current_text);
				return;
			}
			_tmp10_ = selection_ticker;
			selection_ticker = _tmp10_ + 1;
			_g_free0 (current_text);
		}
	}
	g_error ("ExportDialog.vala:175: format_set_active_text: text '%s' isn't in comb" \
"o box", text);
}

static PhotoFileFormat
export_dialog_get_specified_format (ExportDialog* self)
{
	gint index = 0;
	GtkComboBoxText* _tmp0_;
	PhotoFileFormat* writeable_formats = NULL;
	gint _tmp1_ = 0;
	PhotoFileFormat* _tmp2_;
	gint writeable_formats_length1;
	gint _writeable_formats_size_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->format_combo;
	index = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
	if (index < EXPORT_DIALOG_NUM_SPECIAL_FORMATS) {
		index = EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
	}
	index -= EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
	_tmp2_ = photo_file_format_get_writeable (&_tmp1_);
	writeable_formats = _tmp2_;
	writeable_formats_length1 = _tmp1_;
	_writeable_formats_size_ = writeable_formats_length1;
	_tmp3_ = writeable_formats[index];
	result = _tmp3_;
	writeable_formats = (g_free (writeable_formats), NULL);
	return result;
}

static gchar*
export_dialog_get_label_for_parameters (ExportDialog* self,
                                        ExportFormatParameters* params)
{
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (params != NULL, NULL);
	_tmp0_ = *params;
	_tmp1_ = _tmp0_.mode;
	switch (_tmp1_) {
		case EXPORT_FORMAT_MODE_UNMODIFIED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
			result = _tmp2_;
			return result;
		}
		case EXPORT_FORMAT_MODE_CURRENT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
			result = _tmp3_;
			return result;
		}
		case EXPORT_FORMAT_MODE_SPECIFIED:
		{
			ExportFormatParameters _tmp4_;
			PhotoFileFormat _tmp5_;
			PhotoFileFormatProperties* _tmp6_;
			PhotoFileFormatProperties* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp4_ = *params;
			_tmp5_ = _tmp4_.specified_format;
			_tmp6_ = photo_file_format_get_properties (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = photo_file_format_properties_get_user_visible_name (_tmp7_);
			_tmp9_ = _tmp8_;
			_photo_file_format_properties_unref0 (_tmp7_);
			result = _tmp9_;
			return result;
		}
		default:
		{
			g_error ("ExportDialog.vala:200: get_label_for_parameters: unrecognized export f" \
"ormat mode");
		}
	}
}

gboolean
export_dialog_execute (ExportDialog* self,
                       gint* scale,
                       ScaleConstraint* constraint,
                       ExportFormatParameters* parameters)
{
	gint _vala_scale = 0;
	ScaleConstraint _vala_constraint = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	ExportFormatParameters _tmp4_;
	ExportFormatMode _tmp5_;
	ExportFormatParameters _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean ok = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (parameters != NULL, FALSE);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp0_ = *parameters;
	_tmp1_ = _tmp0_.mode;
	if (_tmp1_ != EXPORT_FORMAT_MODE_LAST) {
		ScaleConstraint _tmp2_;
		GtkComboBoxText* _tmp3_;
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
		_tmp2_ = _vala_constraint;
		export_dialog_current_constraint = _tmp2_;
		_tmp3_ = self->priv->constraint_combo;
		gtk_combo_box_set_active ((GtkComboBox*) _tmp3_, 0);
	}
	_tmp4_ = *parameters;
	_tmp5_ = _tmp4_.mode;
	if (_tmp5_ == EXPORT_FORMAT_MODE_LAST) {
		ExportFormatParameters _tmp6_;
		_tmp6_ = export_dialog_current_parameters;
		*parameters = _tmp6_;
	} else {
		gboolean _tmp7_ = FALSE;
		ExportFormatParameters _tmp8_;
		ExportFormatMode _tmp9_;
		_tmp8_ = *parameters;
		_tmp9_ = _tmp8_.mode;
		if (_tmp9_ == EXPORT_FORMAT_MODE_SPECIFIED) {
			ExportFormatParameters _tmp10_;
			PhotoFileFormat _tmp11_;
			_tmp10_ = *parameters;
			_tmp11_ = _tmp10_.specified_format;
			_tmp7_ = !photo_file_format_can_write (_tmp11_);
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			(*parameters).specified_format = photo_file_format_get_system_default_format ();
		}
	}
	_tmp12_ = *parameters;
	_tmp13_ = export_dialog_get_label_for_parameters (self, &_tmp12_);
	_tmp14_ = _tmp13_;
	export_dialog_format_set_active_text (self, _tmp14_);
	_g_free0 (_tmp14_);
	export_dialog_on_format_changed (self);
	ok = gtk_dialog_run ((GtkDialog*) self) == ((gint) GTK_RESPONSE_OK);
	if (ok) {
		gint index = 0;
		GtkComboBoxText* _tmp15_;
		ScaleConstraint _tmp16_;
		ScaleConstraint _tmp17_;
		GtkSpinButton* _tmp18_;
		ScaleConstraint _tmp19_;
		gboolean _tmp20_ = FALSE;
		GtkCheckButton* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
		GtkComboBoxText* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gboolean _tmp30_;
		_tmp15_ = self->priv->constraint_combo;
		index = gtk_combo_box_get_active ((GtkComboBox*) _tmp15_);
		_vala_assert (index >= 0, "index >= 0");
		_tmp16_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[index];
		_vala_constraint = _tmp16_;
		_tmp17_ = _vala_constraint;
		export_dialog_current_constraint = _tmp17_;
		_tmp18_ = self->priv->pixels_spinbutton;
		_vala_scale = (gint) gtk_spin_button_get_value (_tmp18_);
		_tmp19_ = _vala_constraint;
		if (_tmp19_ != SCALE_CONSTRAINT_ORIGINAL) {
			_vala_assert (_vala_scale > 0, "scale > 0");
		}
		export_dialog_current_scale = _vala_scale;
		_tmp21_ = self->priv->export_metadata;
		_tmp22_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp21_);
		_tmp23_ = _tmp22_;
		if (_tmp23_) {
			GtkCheckButton* _tmp24_;
			gboolean _tmp25_;
			gboolean _tmp26_;
			_tmp24_ = self->priv->export_metadata;
			_tmp25_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp24_);
			_tmp26_ = _tmp25_;
			_tmp20_ = _tmp26_;
		} else {
			_tmp20_ = FALSE;
		}
		(*parameters).export_metadata = _tmp20_;
		_tmp27_ = self->priv->format_combo;
		_tmp28_ = gtk_combo_box_text_get_active_text (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strcmp0 (_tmp29_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
		_g_free0 (_tmp29_);
		if (_tmp30_) {
			ExportFormatMode _tmp31_;
			export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_UNMODIFIED;
			_tmp31_ = export_dialog_current_parameters.mode;
			(*parameters).mode = _tmp31_;
		} else {
			GtkComboBoxText* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gboolean _tmp35_;
			_tmp32_ = self->priv->format_combo;
			_tmp33_ = gtk_combo_box_text_get_active_text (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = g_strcmp0 (_tmp34_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
			_g_free0 (_tmp34_);
			if (_tmp35_) {
				ExportFormatMode _tmp36_;
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_CURRENT;
				_tmp36_ = export_dialog_current_parameters.mode;
				(*parameters).mode = _tmp36_;
			} else {
				ExportFormatMode _tmp37_;
				PhotoFileFormat _tmp38_;
				ExportFormatParameters _tmp39_;
				PhotoFileFormat _tmp40_;
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_SPECIFIED;
				_tmp37_ = export_dialog_current_parameters.mode;
				(*parameters).mode = _tmp37_;
				export_dialog_current_parameters.specified_format = export_dialog_get_specified_format (self);
				_tmp38_ = export_dialog_current_parameters.specified_format;
				(*parameters).specified_format = _tmp38_;
				_tmp39_ = export_dialog_current_parameters;
				_tmp40_ = _tmp39_.specified_format;
				if (_tmp40_ == PHOTO_FILE_FORMAT_JFIF) {
					GtkComboBoxText* _tmp41_;
					JpegQuality _tmp42_;
					JpegQuality _tmp43_;
					_tmp41_ = self->priv->quality_combo;
					_tmp42_ = EXPORT_DIALOG_QUALITY_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp41_)];
					export_dialog_current_parameters.quality = _tmp42_;
					_tmp43_ = export_dialog_current_parameters.quality;
					(*parameters).quality = _tmp43_;
				}
			}
		}
	} else {
		_vala_scale = 0;
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
	}
	gtk_widget_destroy ((GtkWidget*) self);
	result = ok;
	if (scale) {
		*scale = _vala_scale;
	}
	if (constraint) {
		*constraint = _vala_constraint;
	}
	return result;
}

static void
export_dialog_on_constraint_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	gboolean jpeg = FALSE;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoFileFormatProperties* _tmp5_;
	PhotoFileFormatProperties* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	GtkSpinButton* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GtkComboBoxText* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->constraint_combo;
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
	_tmp2_ = self->priv->format_combo;
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = photo_file_format_get_properties (PHOTO_FILE_FORMAT_JFIF);
	_tmp6_ = _tmp5_;
	_tmp7_ = photo_file_format_properties_get_user_visible_name (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) == 0;
	_g_free0 (_tmp8_);
	_photo_file_format_properties_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	jpeg = _tmp9_;
	_tmp10_ = self->priv->pixels_spinbutton;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, !original);
	if (!original) {
		_tmp11_ = jpeg;
	} else {
		_tmp11_ = FALSE;
	}
	_tmp12_ = self->priv->quality_combo;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, _tmp11_);
	if (original) {
		GtkWidget* _tmp13_;
		_tmp13_ = self->priv->export_button;
		gtk_widget_set_sensitive (_tmp13_, TRUE);
	} else {
		export_dialog_on_pixels_changed (self);
	}
}

static void
export_dialog_on_format_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->constraint_combo;
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
	_tmp2_ = self->priv->format_combo;
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strcmp0 (_tmp4_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
	_g_free0 (_tmp4_);
	if (_tmp5_) {
		GtkComboBoxText* _tmp6_;
		GtkComboBoxText* _tmp7_;
		GtkComboBoxText* _tmp8_;
		GtkSpinButton* _tmp9_;
		GtkCheckButton* _tmp10_;
		GtkCheckButton* _tmp11_;
		_tmp6_ = self->priv->constraint_combo;
		gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, 0);
		_tmp7_ = self->priv->constraint_combo;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
		_tmp8_ = self->priv->quality_combo;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
		_tmp9_ = self->priv->pixels_spinbutton;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
		_tmp10_ = self->priv->export_metadata;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, FALSE);
		_tmp11_ = self->priv->export_metadata;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
	} else {
		GtkComboBoxText* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
		_tmp12_ = self->priv->format_combo;
		_tmp13_ = gtk_combo_box_text_get_active_text (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strcmp0 (_tmp14_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
		_g_free0 (_tmp14_);
		if (_tmp15_) {
			GtkComboBoxText* _tmp16_;
			GtkComboBoxText* _tmp17_;
			GtkSpinButton* _tmp18_;
			GtkCheckButton* _tmp19_;
			_tmp16_ = self->priv->constraint_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
			_tmp17_ = self->priv->quality_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, FALSE);
			_tmp18_ = self->priv->pixels_spinbutton;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, !original);
			_tmp19_ = self->priv->export_metadata;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
		} else {
			GtkComboBoxText* _tmp20_;
			gboolean jpeg = FALSE;
			gboolean _tmp21_ = FALSE;
			GtkComboBoxText* _tmp22_;
			GtkCheckButton* _tmp23_;
			_tmp20_ = self->priv->constraint_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
			jpeg = export_dialog_get_specified_format (self) == PHOTO_FILE_FORMAT_JFIF;
			if (!original) {
				_tmp21_ = jpeg;
			} else {
				_tmp21_ = FALSE;
			}
			_tmp22_ = self->priv->quality_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, _tmp21_);
			_tmp23_ = self->priv->export_metadata;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, TRUE);
		}
	}
}

static void
export_dialog_on_pixels_changed (ExportDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->pixels_spinbutton;
	if (((gint) gtk_entry_get_text_length ((GtkEntry*) _tmp1_)) > 0) {
		GtkSpinButton* _tmp2_;
		_tmp2_ = self->priv->pixels_spinbutton;
		_tmp0_ = gtk_spin_button_get_value (_tmp2_) > ((gdouble) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkWidget* _tmp3_;
		_tmp3_ = self->priv->export_button;
		gtk_widget_set_sensitive (_tmp3_, TRUE);
	} else {
		GtkWidget* _tmp4_;
		_tmp4_ = self->priv->export_button;
		gtk_widget_set_sensitive (_tmp4_, FALSE);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
	export_dialog_on_constraint_changed ((ExportDialog*) self);
}

static void
_export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
	export_dialog_on_format_changed ((ExportDialog*) self);
}

static void
_export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                       gpointer self)
{
	export_dialog_on_pixels_changed ((ExportDialog*) self);
}

static void
_export_dialog___lambda41_ (ExportDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp1_;
	_tmp1_ = self->priv->pixels_spinbutton;
	if (((gint) gtk_entry_get_text_length ((GtkEntry*) _tmp1_)) > 0) {
		GtkSpinButton* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = self->priv->pixels_spinbutton;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
		_tmp0_ = atoi (_tmp3_) > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
	} else {
		GtkSpinButton* _tmp4_;
		_tmp4_ = self->priv->pixels_spinbutton;
		gtk_spin_button_set_value (_tmp4_, (gdouble) export_dialog_current_scale);
	}
}

static void
__export_dialog___lambda41__gtk_entry_activate (GtkEntry* _sender,
                                                gpointer self)
{
	_export_dialog___lambda41_ ((ExportDialog*) self);
}

static GObject *
export_dialog_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ExportDialog * self;
	GtkLabel* format_label = NULL;
	GtkComboBoxText* _tmp0_;
	GtkWidget* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkComboBoxText* _tmp3_;
	gint _tmp4_ = 0;
	PhotoFileFormat* _tmp5_;
	GtkLabel* quality_label = NULL;
	GtkComboBoxText* _tmp11_;
	GtkWidget* _tmp12_;
	GtkLabel* _tmp13_ = NULL;
	GtkComboBoxText* _tmp14_;
	gint ctr = 0;
	GtkLabel* constraint_label = NULL;
	GtkComboBoxText* _tmp24_;
	GtkWidget* _tmp25_;
	GtkLabel* _tmp26_ = NULL;
	GtkComboBoxText* _tmp27_;
	GtkSpinButton* _tmp36_ = NULL;
	GtkLabel* size_label = NULL;
	GtkSpinButton* _tmp37_;
	GtkWidget* _tmp38_;
	GtkLabel* _tmp39_ = NULL;
	GtkCheckButton* _tmp40_ = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp41_ = NULL;
	GtkGrid* _tmp42_;
	GtkLabel* _tmp43_;
	GtkGrid* _tmp44_;
	GtkComboBoxText* _tmp45_;
	GtkGrid* _tmp46_;
	GtkLabel* _tmp47_;
	GtkGrid* _tmp48_;
	GtkComboBoxText* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	GtkGrid* _tmp52_;
	GtkComboBoxText* _tmp53_;
	GtkGrid* _tmp54_;
	GtkLabel* _tmp55_;
	GtkGrid* _tmp56_;
	GtkSpinButton* _tmp57_;
	GtkGrid* _tmp58_;
	GtkCheckButton* _tmp59_;
	GtkBox* _tmp60_;
	GtkGrid* _tmp61_;
	GtkWidget* _tmp62_;
	GtkWidget* _tmp63_;
	GtkWidget* _tmp64_;
	GtkWidget* _tmp65_;
	GtkWidget* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkWidget* _tmp68_;
	ScaleConstraint _tmp69_;
	GtkComboBoxText* _tmp72_;
	GtkComboBoxText* _tmp73_;
	GtkSpinButton* _tmp74_;
	GtkSpinButton* _tmp75_;
	parent_class = G_OBJECT_CLASS (export_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
	_tmp0_ = self->priv->format_combo;
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	_tmp2_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Format:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
	gtk_label_set_mnemonic_widget (_tmp2_, _tmp1_);
	_g_object_unref0 (_tmp1_);
	gtk_label_set_use_underline (_tmp2_, TRUE);
	g_object_ref_sink (_tmp2_);
	format_label = _tmp2_;
	_tmp3_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->format_combo);
	self->priv->format_combo = _tmp3_;
	export_dialog_format_add_option (self, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
	export_dialog_format_add_option (self, EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
	_tmp5_ = photo_file_format_get_writeable (&_tmp4_);
	{
		PhotoFileFormat* format_collection = NULL;
		gint format_collection_length1 = 0;
		gint _format_collection_size_ = 0;
		gint format_it = 0;
		format_collection = _tmp5_;
		format_collection_length1 = _tmp4_;
		for (format_it = 0; format_it < format_collection_length1; format_it = format_it + 1) {
			PhotoFileFormat format = 0;
			format = format_collection[format_it];
			{
				PhotoFileFormat _tmp6_;
				PhotoFileFormatProperties* _tmp7_;
				PhotoFileFormatProperties* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				_tmp6_ = format;
				_tmp7_ = photo_file_format_get_properties (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = photo_file_format_properties_get_user_visible_name (_tmp8_);
				_tmp10_ = _tmp9_;
				export_dialog_format_add_option (self, _tmp10_);
				_g_free0 (_tmp10_);
				_photo_file_format_properties_unref0 (_tmp8_);
			}
		}
		format_collection = (g_free (format_collection), NULL);
	}
	_tmp11_ = self->priv->quality_combo;
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
	_tmp13_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Quality:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_END);
	gtk_label_set_mnemonic_widget (_tmp13_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	gtk_label_set_use_underline (_tmp13_, TRUE);
	g_object_ref_sink (_tmp13_);
	quality_label = _tmp13_;
	_tmp14_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->quality_combo);
	self->priv->quality_combo = _tmp14_;
	ctr = 0;
	{
		JpegQuality* quality_collection = NULL;
		gint quality_collection_length1 = 0;
		gint _quality_collection_size_ = 0;
		gint quality_it = 0;
		quality_collection = EXPORT_DIALOG_QUALITY_ARRAY;
		quality_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_QUALITY_ARRAY);
		for (quality_it = 0; quality_it < quality_collection_length1; quality_it = quality_it + 1) {
			JpegQuality quality = 0;
			quality = quality_collection[quality_it];
			{
				GtkComboBoxText* _tmp15_;
				JpegQuality _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				JpegQuality _tmp19_;
				ExportFormatParameters _tmp20_;
				JpegQuality _tmp21_;
				gint _tmp23_;
				_tmp15_ = self->priv->quality_combo;
				_tmp16_ = quality;
				_tmp17_ = jpeg_quality_to_string (_tmp16_);
				_tmp18_ = _tmp17_;
				gtk_combo_box_text_append_text (_tmp15_, _tmp18_);
				_g_free0 (_tmp18_);
				_tmp19_ = quality;
				_tmp20_ = export_dialog_current_parameters;
				_tmp21_ = _tmp20_.quality;
				if (_tmp19_ == _tmp21_) {
					GtkComboBoxText* _tmp22_;
					_tmp22_ = self->priv->quality_combo;
					gtk_combo_box_set_active ((GtkComboBox*) _tmp22_, ctr);
				}
				_tmp23_ = ctr;
				ctr = _tmp23_ + 1;
			}
		}
	}
	_tmp24_ = self->priv->constraint_combo;
	_tmp25_ = _g_object_ref0 ((GtkWidget*) _tmp24_);
	_tmp26_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Scaling constraint:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_END);
	gtk_label_set_mnemonic_widget (_tmp26_, _tmp25_);
	_g_object_unref0 (_tmp25_);
	gtk_label_set_use_underline (_tmp26_, TRUE);
	g_object_ref_sink (_tmp26_);
	constraint_label = _tmp26_;
	_tmp27_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->constraint_combo);
	self->priv->constraint_combo = _tmp27_;
	ctr = 0;
	{
		ScaleConstraint* constraint_collection = NULL;
		gint constraint_collection_length1 = 0;
		gint _constraint_collection_size_ = 0;
		gint constraint_it = 0;
		constraint_collection = EXPORT_DIALOG_CONSTRAINT_ARRAY;
		constraint_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_CONSTRAINT_ARRAY);
		for (constraint_it = 0; constraint_it < constraint_collection_length1; constraint_it = constraint_it + 1) {
			ScaleConstraint constraint = 0;
			constraint = constraint_collection[constraint_it];
			{
				GtkComboBoxText* _tmp28_;
				ScaleConstraint _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				ScaleConstraint _tmp32_;
				ScaleConstraint _tmp33_;
				gint _tmp35_;
				_tmp28_ = self->priv->constraint_combo;
				_tmp29_ = constraint;
				_tmp30_ = scale_constraint_to_string (_tmp29_);
				_tmp31_ = _tmp30_;
				gtk_combo_box_text_append_text (_tmp28_, _tmp31_);
				_g_free0 (_tmp31_);
				_tmp32_ = constraint;
				_tmp33_ = export_dialog_current_constraint;
				if (_tmp32_ == _tmp33_) {
					GtkComboBoxText* _tmp34_;
					_tmp34_ = self->priv->constraint_combo;
					gtk_combo_box_set_active ((GtkComboBox*) _tmp34_, ctr);
				}
				_tmp35_ = ctr;
				ctr = _tmp35_ + 1;
			}
		}
	}
	_tmp36_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 999999, (gdouble) 1);
	gtk_spin_button_set_digits (_tmp36_, (guint) 0);
	gtk_entry_set_max_length ((GtkEntry*) _tmp36_, 6);
	gtk_spin_button_set_value (_tmp36_, (gdouble) export_dialog_current_scale);
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->pixels_spinbutton);
	self->priv->pixels_spinbutton = _tmp36_;
	_tmp37_ = self->priv->pixels_spinbutton;
	_tmp38_ = _g_object_ref0 ((GtkWidget*) _tmp37_);
	_tmp39_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Size in pixels:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp39_, GTK_ALIGN_END);
	gtk_label_set_mnemonic_widget (_tmp39_, _tmp38_);
	_g_object_unref0 (_tmp38_);
	gtk_label_set_use_underline (_tmp39_, TRUE);
	g_object_ref_sink (_tmp39_);
	size_label = _tmp39_;
	_tmp40_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Export metadata"));
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp40_, TRUE);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->priv->export_metadata);
	self->priv->export_metadata = _tmp40_;
	_tmp41_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp41_, 12);
	gtk_grid_set_row_spacing (_tmp41_, 6);
	g_object_set ((GtkWidget*) _tmp41_, "margin", 12, NULL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp41_, 0);
	g_object_ref_sink (_tmp41_);
	grid = _tmp41_;
	_tmp42_ = grid;
	_tmp43_ = format_label;
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 0, 0, 1, 1);
	_tmp44_ = grid;
	_tmp45_ = self->priv->format_combo;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 1, 0, 1, 1);
	_tmp46_ = grid;
	_tmp47_ = quality_label;
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 0, 1, 1, 1);
	_tmp48_ = grid;
	_tmp49_ = self->priv->quality_combo;
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 1, 1, 1, 1);
	_tmp50_ = grid;
	_tmp51_ = constraint_label;
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 0, 2, 1, 1);
	_tmp52_ = grid;
	_tmp53_ = self->priv->constraint_combo;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 1, 2, 1, 1);
	_tmp54_ = grid;
	_tmp55_ = size_label;
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 0, 3, 1, 1);
	_tmp56_ = grid;
	_tmp57_ = self->priv->pixels_spinbutton;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 1, 3, 1, 1);
	_tmp58_ = grid;
	_tmp59_ = self->priv->export_metadata;
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 1, 4, 1, 1);
	_tmp60_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp61_ = grid;
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
	_tmp62_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Export"), (gint) GTK_RESPONSE_OK);
	_tmp63_ = _g_object_ref0 (_tmp62_);
	_g_object_unref0 (self->priv->export_button);
	self->priv->export_button = _tmp63_;
	_tmp64_ = self->priv->export_button;
	gtk_widget_set_can_default (_tmp64_, TRUE);
	_tmp65_ = self->priv->export_button;
	g_object_set (_tmp65_, "has-default", TRUE, NULL);
	_tmp66_ = self->priv->export_button;
	_tmp67_ = gtk_widget_get_style_context (_tmp66_);
	gtk_style_context_add_class (_tmp67_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp68_ = self->priv->export_button;
	gtk_widget_grab_focus (_tmp68_);
	_tmp69_ = export_dialog_current_constraint;
	if (_tmp69_ == SCALE_CONSTRAINT_ORIGINAL) {
		GtkSpinButton* _tmp70_;
		GtkComboBoxText* _tmp71_;
		_tmp70_ = self->priv->pixels_spinbutton;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp70_, FALSE);
		_tmp71_ = self->priv->quality_combo;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp71_, FALSE);
	}
	_tmp72_ = self->priv->constraint_combo;
	g_signal_connect_object ((GtkComboBox*) _tmp72_, "changed", (GCallback) _export_dialog_on_constraint_changed_gtk_combo_box_changed, self, 0);
	_tmp73_ = self->priv->format_combo;
	g_signal_connect_object ((GtkComboBox*) _tmp73_, "changed", (GCallback) _export_dialog_on_format_changed_gtk_combo_box_changed, self, 0);
	_tmp74_ = self->priv->pixels_spinbutton;
	g_signal_connect_object ((GtkEditable*) _tmp74_, "changed", (GCallback) _export_dialog_on_pixels_changed_gtk_editable_changed, self, 0);
	_tmp75_ = self->priv->pixels_spinbutton;
	g_signal_connect_object ((GtkEntry*) _tmp75_, "activate", (GCallback) __export_dialog___lambda41__gtk_entry_activate, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (size_label);
	_g_object_unref0 (constraint_label);
	_g_object_unref0 (quality_label);
	_g_object_unref0 (format_label);
	return obj;
}

static void
export_dialog_class_init (ExportDialogClass * klass,
                          gpointer klass_data)
{
	ExportFormatParameters _tmp0_ = {0};
	export_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ExportDialog_private_offset);
	G_OBJECT_CLASS (klass)->constructor = export_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = export_dialog_finalize;
	export_format_parameters_current (&_tmp0_);
	export_dialog_current_parameters = _tmp0_;
}

static void
export_dialog_instance_init (ExportDialog * self,
                             gpointer klass)
{
	GeeArrayList* _tmp0_;
	self->priv = export_dialog_get_instance_private (self);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	self->priv->format_options = _tmp0_;
}

static void
export_dialog_finalize (GObject * obj)
{
	ExportDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
	_g_object_unref0 (self->priv->quality_combo);
	_g_object_unref0 (self->priv->constraint_combo);
	_g_object_unref0 (self->priv->format_combo);
	_g_object_unref0 (self->priv->export_metadata);
	_g_object_unref0 (self->priv->format_options);
	_g_object_unref0 (self->priv->pixels_spinbutton);
	_g_object_unref0 (self->priv->export_button);
	G_OBJECT_CLASS (export_dialog_parent_class)->finalize (obj);
}

static GType
export_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportDialog), 0, (GInstanceInitFunc) export_dialog_instance_init, NULL };
	GType export_dialog_type_id;
	export_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "ExportDialog", &g_define_type_info, 0);
	ExportDialog_private_offset = g_type_add_instance_private (export_dialog_type_id, sizeof (ExportDialogPrivate));
	return export_dialog_type_id;
}

GType
export_dialog_get_type (void)
{
	static volatile gsize export_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&export_dialog_type_id__volatile)) {
		GType export_dialog_type_id;
		export_dialog_type_id = export_dialog_get_type_once ();
		g_once_init_leave (&export_dialog_type_id__volatile, export_dialog_type_id);
	}
	return export_dialog_type_id__volatile;
}

